/*----------------------------------------------------------------------------*/
/* rselect.c:  roulette wheel selection.                                      */
/*----------------------------------------------------------------------------*/

#include "external.h"

char which_selection[] = "rselect.c";

void
select_memory()
{
}

void
select_free()
{
}

void
preselect()
{
    int     j;

    sumfitness = 0;
    for (j = 0; j < popsize; j++)
	sumfitness += oldpop[j].fitness;
}


int
selection()
/* roulette-wheel selection */
/* Bug in original SGA-C found by GALOPPS user Dan Judd; corrected */
/* March 09, 1995 */
{
    float   sum, pick;
    int     i;

    pick = randomperc();
    sum = 0;

    if (sumfitness != 0) {
	for (i = 0; (sum < pick) && (i < popsize); i++) {
	    sum += oldpop[i].fitness / sumfitness;
        }
        i--;  /* decrement because the above loop always goes 1 too far */
    }
    else
	i = rnd(0, popsize - 1);

    return (i);
}
