# readme.tcl

set w .readme
catch {destroy $w}
toplevel $w
wm title $w "README"
wm iconname $w "readme"
positionWindow $w

frame $w.buttons
pack  $w.buttons -side bottom -expand y -fill x -pady 2m
button $w.buttons.dismiss -text Dismiss -command "destroy $w"
pack $w.buttons.dismiss 

text $w.text -yscrollcommand "$w.scroll set" -setgrid true \
	-width 60 -height 21 -font $font -wrap word
scrollbar $w.scroll -command "$w.text yview"
pack $w.scroll -side right -fill y
pack $w.text -expand yes -fill both

# Add text to widget.

$w.text insert 0.0 {
                                                 README

\


To run any application in this distribution, you must first (and only ONCE)
compile all of the "standard" routines in subdirectory galopps3.2\src.  Once
in that directory, simply type "make" (or "gmake", if you had to rename the 
make command to avoid conflict with another make command such as the one in\
Borland C) and all of the .o files will be created.  

Then, to run any example application, change to directory galopps3.2\examples\
and then to the subdirectory for the example you wish to run.  Then, type\
"make" to make an application.  

            FOR DJGPP USERS:

Then you must translate the resulting file,\
(onepop or manypops) using "coff2exe onepop"  or  "coff2exe\manypops", which\
make the .exe file.  

(Alternatively, instead of using coff2exe, there is a sophisticated tool,
go32, which enables debugging, changing of hardware parameters, etc. -- 
HOWEVER, if you want to use that, you must read the documentation for it.)
}
